import { ConfigParams } from 'pip-services3-commons-nodex';
import { MongoDbPersistence } from 'pip-services3-mongodb-nodex';
import { FilterParams } from 'pip-services3-commons-nodex';
import { PagingParams } from 'pip-services3-commons-nodex';
import { DataPage } from 'pip-services3-commons-nodex';
import { BlobInfoV1 } from '../data/version1/BlobInfoV1';
import { IBlobsPersistence } from './IBlobsPersistence';
import { TempBlobStorage } from './TempBlobStorage';
export declare class BlobsMongoDbPersistence extends MongoDbPersistence<BlobInfoV1> implements IBlobsPersistence {
    protected _GridStore: any;
    protected _storage: TempBlobStorage;
    protected _maxBlobSize: number;
    protected _maxPageSize: number;
    constructor();
    configure(config: ConfigParams): void;
    open(correlationId: string): Promise<void>;
    close(correlationId: string): Promise<void>;
    private composeFilter;
    getPageByFilter(correlationId: string, filter: FilterParams, paging: PagingParams): Promise<DataPage<BlobInfoV1>>;
    getListByIds(correlationId: string, ids: string[]): Promise<BlobInfoV1[]>;
    getOneById(correlationId: string, id: string): Promise<BlobInfoV1>;
    update(correlationId: string, item: BlobInfoV1): Promise<BlobInfoV1>;
    markCompleted(correlationId: string, ids: string[]): Promise<void>;
    isUriSupported(): boolean;
    getUri(correlationId: string, id: string): Promise<string>;
    private infoToToken;
    private tokenToInfo;
    beginWrite(correlationId: string, item: BlobInfoV1): Promise<string>;
    writeChunk(correlationId: string, token: string, chunk: string): Promise<string>;
    endWrite(correlationId: string, token: string, chunk: string): Promise<BlobInfoV1>;
    abortWrite(correlationId: string, token: string): Promise<void>;
    private gridToInfo;
    beginRead(correlationId: string, id: string): Promise<BlobInfoV1>;
    readChunk(correlationId: string, id: string, skip: number, take: number): Promise<string>;
    endRead(correlationId: string, id: string): Promise<void>;
    deleteById(correlationId: string, id: string): Promise<BlobInfoV1>;
    deleteByIds(correlationId: string, ids: string[]): Promise<void>;
    clear(correlationId: string): Promise<void>;
}
